51nod部分容斥题解
跟容斥没有关系。首先可以确定的一个结论是:对于任意正整数,有1*2*...*n | (k+1)*(k+2)*...*(k+n)。因为这就是$C_{n+k}^{k}$。
于是这题就有:m最多枚举到2n。
于是有一个做法:对n!分解质因数,然后枚举m的同时统计已获得的所有质因数的次幂,全部不小于n!时即可推出。
复杂度肯定不大于$O(n\log n)$。
同时这里有一个不会证的结论:找到n以内最大的$p^k$的数(p是质数),答案就是$2p^k$。
$O(n\log n)$
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
typedef long long ll;
using namespace std; const int N=;
int T,n,tot,cnt[N],cnt2[N],pr[N],b[N],id[N]; void init(int n){
rep(i,,n){
if (!b[i]) pr[++tot]=i,id[i]=tot;
for (int j=; j<=tot && pr[j]*i<=n; j++){
b[pr[j]*i]=;
if (i%pr[j]==) break;
}
}
} int main(){
init();
for (scanf("%d",&T); T--; ){
scanf("%d",&n); int g=;
for (int i=; i<=tot && pr[i]<=n; i++)
for (int j=pr[i]; j<=n; j*=pr[i]) g=max(g,j);
printf("%d\n",g*);
}
return ;
}
51nod1434
先把所有坏点按曼哈顿距离排序。
总方案数减去不合法方案的数量,枚举第一次走到的不合法格子(x,y),则答案就是(走合法格子到(x,y)的路径数)*C(n-x,m-y)。而走合法格子到(x,y)的路径数用同样的方法算即可。
$O(n^2)$
#include<cstdio>
#include<algorithm>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
using namespace std; const int N=,mod=1e9+;
int n,m,K,fac[N],inv[N],f[N];
struct P{ int x,y; }p[N];
bool operator <(const P &a,const P &b){ return (a.x==b.x) ? a.y<b.y : a.x<b.x; }
int C(int n,int m){ return n<m ? : 1ll*fac[n]*inv[m]%mod*inv[n-m]%mod; } int ksm(int a,int b){
int res=;
for (; b; a=1ll*a*a%mod,b>>=)
if (b & ) res=1ll*res*a%mod;
return res;
} void init(int n){
fac[]=; rep(i,,n) fac[i]=1ll*fac[i-]*i%mod;
inv[n]=ksm(fac[n],mod-);
for (int i=n-; ~i; i--) inv[i]=1ll*inv[i+]*(i+)%mod;
} int main(){
scanf("%d%d%d",&n,&m,&K); init(n+m);
rep(i,,K) scanf("%d%d",&p[i].x,&p[i].y);
sort(p+,p+K+); p[++K]=(P){n,m};
rep(i,,K){
int res=C(p[i].x+p[i].y-,p[i].x-);
rep(j,,i-) if (p[j].x<=p[i].x && p[j].y<=p[i].y)
res=(res-1ll*f[j]*C(p[i].x-p[j].x+p[i].y-p[j].y,p[i].x-p[j].x)%mod+mod)%mod;
f[i]=res;
}
printf("%d\n",f[K]);
return ;
}
51nod1486
简单莫比乌斯容斥,答案是$\sum\limits_{d|x}\mu(d)\sum\limits_{d|i}a[i]$。
先线性筛出$\mu$,再对每个d维护$\sum\limits_{d|i}a[i]$,事先将每个数的因子全部预处理出来以减小常数。
$O(n*n^\frac{1.44}{\ln \ln n})$(据说n的因子个数是$n^\frac{1.44}{\ln \ln n}$级别的,当然肯定不满)
#include<vector>
#include<cstdio>
#include<algorithm>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
typedef long long ll;
using namespace std; const int N=;
int n,Q,tot,op,x,k,a[N],sm[N],miu[N],pr[N],b[N];
vector<int>ve[N]; void init(int n){
rep(i,,n){
if (!b[i]) pr[++tot]=i,miu[i]=-;
for (int j=; j<=tot && pr[j]*i<=n; j++){
b[pr[j]*i]=;
if (i%pr[j]==) { miu[pr[j]*i]=; break; }
else miu[pr[j]*i]=-miu[i];
}
}
rep(i,,n) for (int j=i; j<=n; j+=i) ve[j].push_back(i);
} int main(){
scanf("%d%d",&n,&Q); miu[]=; init();
rep(i,,n){
scanf("%d",&a[i]); int ed=ve[i].size()-;
rep(j,,ed) sm[ve[i][j]]+=a[i];
}
rep(i,,Q){
scanf("%d",&op);
if (op==){
scanf("%d%d",&x,&k); int ed=ve[x].size()-;
rep(i,,ed) sm[ve[x][i]]+=k-a[x];
a[x]=k;
}else{
scanf("%d",&x); int ed=ve[x].size()-; ll res=;
rep(i,,ed) res+=sm[ve[x][i]]*miu[ve[x][i]];
printf("%lld\n",res);
}
}
return ;
}
51nod1678
比较巧妙的DP,具体见代码。注意这题需要快速读入与输出。
$O(A\log A)$
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
typedef long long ll;
using namespace std; const int N=;
int n,x,mx,ww[],f[N]; inline void rd(int &x){
x=; char ch=getchar();
while (ch<'' || ch>'') ch=getchar();
while (ch>='' && ch<='') x=(x<<)+(x<<)+(ch^),ch=getchar();
} inline void pr(int x){
int tot=;
if (!x) { putchar(''); return; }
while (x) ww[++tot]=x%,x/=;
while (tot) putchar(ww[tot--]+'');
} int main(){
rd(n);
rep(i,,n) rd(x),mx=max(mx,x),f[x]++;
for (int i=; i<=mx; i<<=)
for (int j=mx; j; j--) if (i&j) f[j-i]+=f[j];
rep(i,,) pr(f[i]),putchar('\n');
return ;
}
51nod1406
考虑容斥,求“相邻后至少k位为1”的方案数f(x),答案就是$2^{f(x)}-1$。求f(x)就是上一道题。
$O(A\log A)$
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
typedef long long ll;
using namespace std; const int N=,mod=1e9+;
int n,x,mx,ans,f[N]; int ksm(int a,int b){
int res=;
for (; b; a=1ll*a*a%mod,b>>=)
if (b & ) res=1ll*res*a%mod;
return res;
} int Cnt(int x){
int res=;
for (; x; x>>=) if (x&) res=-res;
return res;
} int main(){
while (~scanf("%d",&n)){
rep(i,,mx) f[i]=; mx=ans=;
rep(i,,n) scanf("%d",&x),mx=max(mx,x),f[x]++;
for (int i=; i<=mx; i<<=)
for (int j=mx; j; j--) if (i&j) f[j-i]+=f[j];
rep(i,,mx) ans=(ans+Cnt(i)*(ksm(,f[i])-))%mod;
printf("%d\n",(ans+mod)%mod);
}
return ;
}
51nod1407
好题。https://blog.csdn.net/samjia2000/article/details/53025218
$O(2^{k1+k2})$
#include<cstdio>
#include<algorithm>
#include<cstring>
#define rep(i,l,r) for (int i=(l); i<=(r); i++)
using namespace std; const int N=,mod=1e9+;
int T,n,m,l,r,s,sm,ans1,ans2,ans3,len[N]; int ksm(int a,int b){
int res=;
for (; b; a=1ll*a*a%mod,b>>=)
if (b & ) res=1ll*res*a%mod;
return res;
} int C(int n,int m){
if (n<m) return ;
int res=;
rep(i,,m) res=1ll*res*(n-m+i)%mod*ksm(i,mod-)%mod;
return res;
} void dfs(int x,int t,int d){
if (x>n+m){
ans1=(ans1+1ll*t*C(sm-d+n+m-,n+m)+mod)%mod;
ans2=(ans2+1ll*t*C(sm-d+n+m-,n+m-)+mod)%mod;
return;
}
dfs(x+,t,d); dfs(x+,-t,d+len[x]);
} int main(){
for (scanf("%d",&T); T--; ){
scanf("%d",&n); s=; sm=ans1=ans2=;
rep(i,,n) scanf("%d%d",&l,&r),sm+=r,len[i]=r-l+,s=1ll*s*len[i]%mod;
scanf("%d",&m);
rep(i,,m) scanf("%d%d",&l,&r),sm-=l,len[i+n]=r-l+,s=1ll*s*len[i+n]%mod;
dfs(,,); ans3=(1ll*s-ans1-ans2+mod+mod)%mod; s=ksm(s,mod-);
ans1=1ll*ans1*s%mod; ans2=1ll*ans2*s%mod; ans3=1ll*ans3*s%mod;
printf("%d %d %d\n",ans1,ans2,ans3);
}
return ;
}
51nod1667
51nod部分容斥题解的更多相关文章
- [SDOI2009]Bill的挑战——全网唯一 一篇容斥题解
全网唯一一篇容斥题解 Description Solution 看到这个题,大部分人想的是状压dp 但是我是个蒟蒻没想到,就用容斥切掉了. 并且复杂度比一般状压低, (其实这个容斥的算法,提出来源于y ...
- 2 3 5 7的倍数 (51Nod - 1284)[容斥定理]
20180604 给出一个数N,求1至N中,有多少个数不是2 3 5 7的倍数. 例如N = 10,只有1不是2 3 5 7的倍数. Input 输入1个数N(1 <= N <= 10^1 ...
- 洛谷P4707 重返现世(扩展MinMax容斥+dp)
传送门 我永远讨厌\(dp.jpg\) 前置姿势 扩展\(Min-Max\)容斥 题解 看纳尔博客去→_→ 咱现在还没搞懂为啥初值要设为\(-1\)-- //minamoto #include< ...
- 【题解】Counting D-sets(容斥+欧拉定理)
[题解]Counting D-sets(容斥+欧拉定理) 没时间写先咕咕咕. vjCodeChef - CNTDSETS 就是容斥,只是难了一二三四五\(\dots \inf\)点 题目大意: 给定你 ...
- 【题解】CF559C C. Gerald and Giant Chess(容斥+格路问题)
[题解]CF559C C. Gerald and Giant Chess(容斥+格路问题) 55336399 Practice: Winlere 559C - 22 GNU C++11 Accepte ...
- 51Nod 1486 大大走格子 —— 容斥
题目:http://www.51nod.com/onlineJudge/questionCode.html#!problemId=1486 对于每个点,求出从起点到它,不经过其他障碍点的方案数: 求一 ...
- [CQOI2014]数三角形 题解(组合数学+容斥)
[CQOI2014]数三角形 题解(数论+容斥) 标签:题解 阅读体验:https://zybuluo.com/Junlier/note/1328780 链接题目地址:洛谷P3166 BZOJ 350 ...
- 51nod 1518 稳定多米诺覆盖(容斥+二项式反演+状压dp)
[传送门[(http://www.51nod.com/Challenge/Problem.html#!#problemId=1518) 解题思路 直接算不好算,考虑容斥,但并不能把行和列一起加进去容斥 ...
- 【题解】毒蛇越狱(FWT+容斥)
[题解]毒蛇越狱(FWT+容斥) 问了一下大家咋做也没听懂,按兵不动没去看题解,虽然已经晓得复杂度了....最后感觉也不难 用FWT_OR和FWT_AND做一半分别求出超集和和子集和,然后 枚举问号是 ...
随机推荐
- 【洛谷 P4134】 [BJOI2012]连连看(费用流)
题目链接 首先是可以\(O(n^2)\)枚举出所有符合要求的点对的,然后考虑建图. 还是拆点把每个点拆成入点和出点,源点连入点,出点连汇点,流量都是1,费用都是0. 然后对于没对符合要求的\((x,y ...
- 【洛谷 P3705】 [SDOI2017]新生舞会(费用流,01分数规划)
题目链接 看到这题我想到了以前做过的一题,名字记不清了,反正里面有"矩阵"二字,然后是道二分图匹配的题. 经典的行列连边网络流. 第\(i\)行和第\(j\)列连边,费用为\(b[ ...
- 删除none的images
脚本 #!/bin/bash docker ps -a | grep "Exited" | awk '{print $1 }'|xargs docker stop docker p ...
- 不相交集ADT--数组实现
不相交集是解决等价问题的一种有效的数据结构,之所以称之为有效是因为,这个数据结构简单(几行代码,一个简单数组就可以搞定),快速(每个操作基本上可以在常数平均时间内搞定). 首先我们要明白什么叫做等价关 ...
- UVA 1103 How Many O's?
题目链接:UVA-11038 题意为给定n和m,求n和m之间(包含)的所有数包含的0的个数. 思路是,用cal(x)表示小于等于x的数包含的0的个数.则答案为cal(n)-cal(m-1). 再把求c ...
- linux/centos定时任务cron
https://www.cnblogs.com/p0st/p/9482167.html cron: crond进程 crontab修改命令 * * * * * command parameter & ...
- jsonpath for js
/** * @license * JSONPath 0.8.0 - XPath for JSON * * Copyright (c) 2007 Stefan Goessner (goessner.ne ...
- docvalue and fielddata
大部分字段类型默认被索引的(inverted index),可以被搜索search: 哪个文档有这个词sort&aggregations: look up the document and f ...
- Git分支管理小结
分支管理命令 每次提交,Git都把它们串成一条时间线,这条时间线就是一个分支.截止到目前,只有一条时间线,在Git里,这个分支叫主分支,即master分支.HEAD严格来说不是指向提交,而是指向mas ...
- 使用亚马逊云服务器EC2做深度学习(二)配置Jupyter Notebook服务器
这是<使用亚马逊云服务器EC2做深度学习>系列的第二篇文章. (一)申请竞价实例 (二)配置Jupyter Notebook服务器 (三)配置TensorFlow (四)配置好的系统 ...